"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
// Do not export singleton class
class SuiteCollection extends Array {
    get head() {
        if (!this.length)
            throw new Error('This collection has no suite');
        return this[this.length - 1];
    }
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            console.log('Launching: total test suites', this.length);
            for (let i = 0; i < this.length; i++) {
                const suite = this[i];
                yield suite.run();
            }
            console.log('Finished: Total', this.length, 'test suites have run.');
        });
    }
}
exports.SuiteCollection = SuiteCollection;
exports.suiteCollection = new SuiteCollection();
