"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
class Test {
    constructor(testArgs) {
        this.testArgs = testArgs;
    }
    get fn() {
        return this.testArgs.fn;
    }
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                this.fn.constructor.name === 'GeneratorFunction'
                    ? yield this.runGeneratorFn()
                    : yield this.runFn();
                console.log('Passed: ', this.testArgs.name);
            }
            catch (e) {
                console.error('Failed:', this.testArgs.name);
                console.error(e);
            }
        });
    }
    runFn() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.fn.length === 0)
                return this.fn();
            yield this.runFnWithDone();
        });
    }
    runFnWithDone() {
        return new Promise((resolve, reject) => {
            const timeout = setTimeout(() => {
                reject(new Error('Failed: timeout'));
            }, 1000);
            const done = () => {
                clearTimeout(timeout);
                resolve();
            };
            this.fn(done);
        });
    }
    // Deprecated: support for generator function will be removed in v4.0.0
    runGeneratorFn() {
        console.error('Deprecated: support for generator function will be removed in v4.0.0');
        return new Promise((resolve, reject) => {
            const gen = this.fn();
            maxAPI.addHandler(this.testArgs.target, (actual) => {
                let done;
                try {
                    done = gen.next(actual).done;
                }
                catch (e) {
                    maxAPI.removeHandlers(this.testArgs.target);
                    reject(e);
                }
                finally {
                    if (done) {
                        maxAPI.removeHandlers(this.testArgs.target);
                        resolve();
                    }
                }
            });
            gen.next();
        });
    }
}
exports.Test = Test;
