"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const glob = require("glob");
const SuiteCollection_1 = require("./SuiteCollection");
const Suite_1 = require("./Suite");
const fs = require("fs-extra");
const execContext_1 = require("./execContext");
const exec_1 = require("./exec");
// Do not export singleton class
class TestLoader {
    constructor(suiteCollection) {
        this.suiteCollection = suiteCollection;
    }
    execTestFiles({ testCodeDir }) {
        return __awaiter(this, void 0, void 0, function* () {
            const files = glob.sync('{,!(node_modules)/**/}*.js', {
                cwd: testCodeDir,
                absolute: true
            });
            if (files.length === 0) {
                throw new Error(`No test code found in ${testCodeDir}`);
            }
            console.log('Loading:', files.length, 'files');
            files.forEach((file) => {
                this.suiteCollection.push(new Suite_1.Suite());
                const script = fs.readFileSync(file, 'utf-8');
                exec_1.exec(script, execContext_1.generateExecContext(this.suiteCollection));
            });
        });
    }
}
exports.testLoader = new TestLoader(SuiteCollection_1.suiteCollection);
