"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ConfigLoader_1 = require("./ConfigLoader");
const SuiteCollection_1 = require("./SuiteCollection");
const TestLoader_1 = require("./TestLoader");
exports.main = () => __awaiter(void 0, void 0, void 0, function* () {
    try {
        console.log('Starting');
        const config = yield ConfigLoader_1.configLoader.run();
        yield TestLoader_1.testLoader.execTestFiles(config);
        yield SuiteCollection_1.suiteCollection.run();
    }
    catch (e) {
        console.error(e);
    }
});
exports.main();
